#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\edit.h>
#include <owl\dc.h>
#include <owl\groupbox.h>
#include <owl\radiobut.h>
#include <stdlib.h>
#include <owl\validate.h>
#include <math.h>
#include "pr74_1.rc"

class TApp : public TApplication
	{
	 public :
		 TApp() : TApplication() {};
		 void InitMainWindow();
	};

class TWndw : public TFrameWindow
	{
	 public :
		 TWndw(TWindow *parent, const char far *title);
	 protected :
		 TEdit *str1,*str2,*str3;
		 TRadioButton *r1,*r2,*r3,*r4;
		 BOOL CanClose();
		 DECLARE_RESPONSE_TABLE(TWndw);
		 void SetupWindow();
       void CmMul();
		 void CmDiv();
		 void CmPlus();
		 void CmVich();
		 void CmClear();
	};

DEFINE_RESPONSE_TABLE1(TWndw,TFrameWindow)
	  EV_COMMAND(CM_CLEAR,CmClear),
	  EV_COMMAND(ID_MUL,CmMul),
	  EV_COMMAND(ID_DIV,CmDiv),
	  EV_COMMAND(ID_PLUS,CmPlus),
	  EV_COMMAND(ID_VICH,CmVich),
END_RESPONSE_TABLE;

TWndw::TWndw(TWindow *parent, const char far *title):
				 TFrameWindow(parent, title)
	{
	 TValidator *valid;
	 Attr.X=50;
	 Attr.Y=50;
	 Attr.W=270;
	 Attr.H=150;
	 EnableKBHandler();
	 str1=new TEdit(this, ID_STR1,"",10,26,60,25,10);
	 valid=new TFilterValidator("-0-9.");
	 str1->SetValidator(valid);
	 str2=new TEdit(this, ID_STR2,"",110,26,60,25,10);
	 str2->SetValidator(valid);
	 str3=new TEdit(this, ID_STR3,"",195,26,60,25,10);
	 valid=new TFilterValidator("");
	 str3->SetValidator(valid);
	 new TButton(this,CM_CLEAR,"",80,75,71,25);
	 r1 = new TRadioButton(this,ID_MUL,"",79,10,23,10,0);
	 r2 = new TRadioButton(this,ID_DIV,"/",79,24,23,10);
	 r3 = new TRadioButton(this,ID_PLUS,"+",79,38,23,10);
	 r4 = new TRadioButton(this,ID_VICH,"-",79,52,23,10);
	 new TStatic(this,-1," =",175,28,15,15,1);
	}

void TWndw::SetupWindow()
{
  TFrameWindow::SetupWindow();
}

BOOL TWndw::CanClose()
	{
	 int result=MessageBox("?","",MB_YESNO|MB_ICONQUESTION);
	 if (result==IDYES) return TRUE;
	 else return FALSE;
	}

void TWndw::CmMul()
	{
	  char *s1,*s2,*s3;
	  double k;
	  str3->Clear();
	  s1=new char[10];
	  s2=new char[10];
	  s3=new char[10];
	  str1->GetLine(s1,10,1);
	  str2->GetLine(s2,10,1);
	  if (strlen(s1) && strlen(s2))
		 { k = atof(s1)*atof(s2);
			gcvt(k,9,s3);
			str3->Insert(s3);
		 }
	  else
		 { MessageBox("   !","",MB_ICONEXCLAMATION);
		 }
          delete [] s1; 
          delete [] s2; 
          delete [] s3; 
	}

void TWndw::CmDiv()
	{
	  char *s1,*s2,*s3;
	  double k;
	  str3->Clear();
	  s1=new char[10];
	  s2=new char[10];
	  s3=new char[10];
	  str1->GetLine(s1,10,2);
	  str2->GetLine(s2,10,2);
	  if (strlen(s1) && strlen(s2))
		 { if (atof(s2)!=0)
			  {
				 k = atof(s1)/atof(s2);
				 gcvt(k,9,s3);
				 str3->Insert(s3);
			  }
			else
			  {
				 MessageBox("   !","",MB_ICONEXCLAMATION);
				 //str2->Clear();
			  }
		 }
	  else
		 {
			MessageBox("   !","",MB_ICONEXCLAMATION);
		 }
          delete [] s1; 
          delete [] s2; 
          delete [] s3; 
	}

void TWndw::CmPlus()
	{
	  char *s1,*s2,*s3;
	  double k;
	  str3->Clear();
	  s1=new char[10];
	  s2=new char[10];
	  s3=new char[10];
	  str1->GetLine(s1,10,1);
	  str2->GetLine(s2,10,1);
	  if (strlen(s1) && strlen(s2))
		 { k = atof(s1)+atof(s2);
			gcvt(k,9,s3);
			str3->Insert(s3);
		 }
	  else
		 { MessageBox("   !","",MB_ICONEXCLAMATION);
		 }
          delete [] s1; 
          delete [] s2; 
          delete [] s3; 
	}

void TWndw::CmVich()
	{
	  char *s1,*s2,*s3;
	  double k;
	  str3->Clear();
	  s1=new char[10];
	  s2=new char[10];
	  s3=new char[10];
	  str1->GetLine(s1,10,1);
	  str2->GetLine(s2,10,1);
	  if (strlen(s1) && strlen(s2))
		 { k = atof(s1)-atof(s2);
			gcvt(k,9,s3);
			str3->Insert(s3);
		 }
	  else
		 { MessageBox("   !","",MB_ICONEXCLAMATION);
		 }
          delete [] s1; 
          delete [] s2; 
          delete [] s3; 
	}

void TWndw::CmClear()
	{
	  str1->Clear();
	  str2->Clear();
	  str3->Clear();
	  str1->SetFocus();
	}

void TApp::InitMainWindow()          //TWindow
	{
	 TWndw *wndw=new TWndw(0,"  ");
	 wndw->SetBkgndColor(13409000);
	 SetMainWindow(wndw);
	}

int OwlMain(int, char* [])
	{
	 return TApp().Run();
	}